function  [L,U,P]=fatt_lu_pr(A)
% funzione che ci restituisce la fattorizzazione LU di A.

n = length(A);  % dimensione della matrice
L = zeros(n);     % pre-definisco L
P = eye(n);     % predefinisco la matrice di permutazione


U = A;
for i = 1:n-1
  % scambiare la riga i-esima con la riga k-esima, data dall'elemento a_ki
  % che in modulo e' maggiore di qualsiasi altro elemento della colonna a_.i 
  [m, k] = max(abs(U(i:n,i)));  % troviamo la posizione del massimo nella sottocolonna i-esima
  j      = i+k-1;

  [U, Pij] = permutazione(U,i,j);   % permutato le righe i e j della matrice U 
  [L, Pij] = permutazione(L,i,j);   % permuto le righe i e j della matrice L
  P = Pij*P;                       % aggiorno la matrice permutazione  
  % riga i-esima di L.
  for r = i+1:n          % eliminazione
      L(r,i) = U(r,i)/U(i,i);                % termine di pivot
      U(r,i:n) = U(r,i:n) - L(r,i)*U(i,i:n); % sottraggo la riga i alla riga r
  end
end
L =  L + eye(n);  % definisco gli elementi sulla diagonale di L.

end

%% Esercizio: scrivere dei comandi in modo da restituire la matrice P di permutazione.
%             e visualizzarla sulla shell.
